/*

  Names plugin
    
*/

var Names = new Plugin('names');
var NameWidget = new Array;

Names.onload = function() {
  this.refresh();
};

Names.refresh = function() {
  this.Design.clean();
  this.nowExpand = false;

  // timeout should be set to absolute tile = 00h 00 by computing offset to new day
  setTimeout(this.refresh.bind(this), 15*60*1000);
  
  var maxShrinked  = ((this.Settings.maxDays > 5)? 5 : this.Settings.maxDays);
  var maxStretched = ((this.Settings.maxDaysExpanded > 5)? 5 : this.Settings.maxDaysExpanded);
  var maxExpanded  = (((Settings.allowExpand) && (this.Settings.allowExpand))? maxStretched : ((this.Settings.defNamesState == 'shrinked')? maxShrinked : maxStretched));

  var custom = this.Design.generateCustom('','names-content','names');

  // The offsets are computed including bissextile years (as it's an offset depending on the date only)
  var offset = [0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335];
  var NbJoursMois = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  var currentDate = new Date();

  // Compute index of Day in Year (Offset array handles automatically bissextile years)
  var index = parseInt(currentDate.getDate() + offset[currentDate.getMonth()] - 1); 

  // Add Name of the Day header
  var head = this.Design.appendHeader($L('Name of the day')+((maxShrinked == 0)?":&nbsp;&nbsp;"+this.names[index]:''));
  
  var old_height = head.style.height;
  var old_overfl = head.style.overflow;
  var old_whites = head.style.whiteSpace; 
  head.style.height = 'auto';
  
  var height = head.getDimensions().height;
  head.style.whiteSpace = 'normal';
  head.style.overflow = 'visible';
  
  if(head.getDimensions().height == height) {
  	// Compute next day date and index
  	var bissextile = parseInt((((currentDate.getMonth() == 2)&&((currentDate.getFullYear() % 400 == 0)||((currentDate.getFullYear() % 4 == 0)&&(currentDate.getFullYear () % 100 != 0))))?1:0));
    
    	if (currentDate.getDate() == (NbJoursMois[currentDate.getMonth()-1]+ bissextile)) {
    		currentDate.setDate(1);
    		if (currentDate.getMonth() == 12) {
    			currentDate.setMonth(1);
    			currentDate.setFullYear(currentDate.getFullYear()+1);
    		}
  		else
    			currentDate.setMonth(currentDate.getMonth()+1);
    	} else
    		currentDate.setDate(currentDate.getDate()+1);
    
  	index = parseInt(currentDate.getDate() + offset[currentDate.getMonth()] - 1); 
  }
  
  head.style.height = old_height;
  head.style.overflow = old_overfl;
  head.style.whiteSpace = old_whites;
  
  for (i = 0; i < maxExpanded; i++) {
      
	//Create the hidden div if over limit
	if ((i >= maxShrinked) && (!this.nowExpand)) {
		this.Design.appendCustom(custom);
		custom = custom.appendChild(this.Design.generateCustom('','names-content','names-expand'));
		custom.style.display = (this.Settings.defNamesState == 'shrinked' && !this.expanded)?'none':'block';
		this.expanded = (!(this.Settings.defNamesState == 'shrinked' && !this.expanded));
		this.nowExpand = true;
	}

	//Add Inner Header bar
	if (!this.Settings.groupNames) {
		if(currentDate.isToday())
			custom.appendChild(this.Design.generateHeader($L('Today'), 'dayHeader'));
		else if(currentDate.isTomorrow())
			custom.appendChild(this.Design.generateHeader($L('Tomorrow'), 'dayHeader'));
		else
			custom.appendChild(this.Design.generateHeader(currentDate.format($S('longDate')), 'dayHeader'));
  	}

	//Add the list of names for currentDate
	custom.appendChild(this.Design.generateSummary(this.names[index]));
  
	if(!this.Settings.groupNames) {
//		custom.appendChild(this.Design.generateLocation(currentDate.format($S('formatTime'))+timeStr));
	} else if (currentDate.isToday())
		custom.appendChild(this.Design.generateLocation($L('Today')));
	else if (currentDate.isTomorrow())
		custom.appendChild(this.Design.generateLocation($L('Tomorrow')));
	else
		custom.appendChild(this.Design.generateLocation(currentDate.format($S('longDate'))));

	// Compute next day date and index
      bissextile = parseInt((((currentDate.getMonth() == 2)&&((currentDate.getFullYear() % 400 == 0)||((currentDate.getFullYear() % 4 == 0)&&(currentDate.getFullYear () % 100 != 0))))?1:0));

	if (currentDate.getDate() == (NbJoursMois[currentDate.getMonth()-1]+ bissextile)) {
  		currentDate.setDate(1);
  		if (currentDate.getMonth() == 12) {
  			currentDate.setMonth(1);
  			currentDate.setFullYear(currentDate.getFullYear()+1);
  		}
  		else
    			currentDate.setMonth(currentDate.getMonth()+1);
  	} else
  		currentDate.setDate(currentDate.getDate()+1);
  
  	index = parseInt(currentDate.getDate() + offset[currentDate.getMonth()] - 1); 
  }
    
  this.Design.appendCustom(custom);  
  
  if(this.nowExpand) {
  	this.Design.appendCustom('. . .','expand');
  	this.expandable = 'names-expand';
  	this.reservedHeight = parseInt(custom.getDimensions().height);
   	this.setToggle();
  }

};


document.write('<script type="text/javascript" src="plugins/names/lang/en.names.js"><\/script>');
document.write('<script type="text/javascript" src="plugins/names/lang/'+Controller.language.substring(0,2)+'.names.js"><\/script>');
if(Controller.language.length > 2)
  document.write('<script type="text/javascript" src="plugins/names/lang/'+Controller.language+'.names.js"><\/script>');

Controller.registerPlugin(Names);
